package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseBreed;
import com.ruoyi.web.base.service.IBaseBreedService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-02
 */
@RestController
@RequestMapping("/base-breed")
public class BaseBreedController {
    @Autowired
    private IBaseBreedService baseBreedService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("畜种管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseBreed baseBreed, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseBreedService.count(new QueryWrapper<BaseBreed>().eq("org_id",loginOrgId).eq("breed_num", baseBreed.getBreedName())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseBreed.setOrgId(tokenService.getLoginOrgId(request));
        baseBreed.setCreateBy(getUsername());

        return success(baseBreedService.save(baseBreed));
    }

    @ApiOperation("畜种管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseBreed baseBreed, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseBreedService.count(new QueryWrapper<BaseBreed>().ne("id",baseBreed.getId()).eq("org_id",loginOrgId).eq("breed_num", baseBreed.getBreedName())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseBreed.setUpdateBy(getUsername());
        return success(baseBreedService.updateById(baseBreed));
    }

    @ApiOperation("畜种管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseBreedService.removeById(s);
        }
        return success();
    }

    @ApiOperation("畜种管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseBreedService.list(new QueryWrapper<BaseBreed>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("畜种管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseBreedService.page(new Page<BaseBreed>(pageNum,pageSize),new QueryWrapper<BaseBreed>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("畜种管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseBreedService.getById(id));
    }

}
